// RainbowChainWalkContainer.cpp: implementation of the CRainbowChainWalkContainer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RainbowCrack.h"
#include "RainbowChainWalkContainer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////

CRainbowChainWalkContainer::CRainbowChainWalkContainer()
{
}

CRainbowChainWalkContainer::~CRainbowChainWalkContainer()
{
	DiscardAll();
}

void CRainbowChainWalkContainer::DiscardAll()
{
	//printf("debug: discarding all walk ...\n");

	int i;
	for (i = 0; i < m_arrRainbowChainWalk.GetSize(); i++)
		delete[] m_arrRainbowChainWalk[i].pIndexE;
	m_arrRainbowChainWalk.RemoveAll();
}

BOOL CRainbowChainWalkContainer::RequestWalk(CString sPlainCharset, int nRainbowTableIndex,
											 int nRainbowChainLength, RainbowChainWalk& rcw)
{
	if (   m_sPlainCharset       != sPlainCharset
		|| m_nRainbowTableIndex  != nRainbowTableIndex
		|| m_nRainbowChainLength != nRainbowChainLength)
	{
		DiscardAll();

		m_sPlainCharset       = sPlainCharset;
		m_nRainbowTableIndex  = nRainbowTableIndex;
		m_nRainbowChainLength = nRainbowChainLength;

		rcw.pIndexE = new unsigned __int64[m_nRainbowChainLength - 1];
		m_arrRainbowChainWalk.Add(rcw);
		return TRUE;
	}

	int i;
	for (i = 0; i < m_arrRainbowChainWalk.GetSize(); i++)
	{
		if (memcmp(m_arrRainbowChainWalk[i].Hash, rcw.Hash, 8) == 0)
		{
			rcw.pIndexE = m_arrRainbowChainWalk[i].pIndexE;
			return FALSE;
		}
	}

	rcw.pIndexE = new unsigned __int64[m_nRainbowChainLength - 1];
	m_arrRainbowChainWalk.Add(rcw);
	return TRUE;
}

void CRainbowChainWalkContainer::DiscardWalk(RainbowChainWalk rcw)
{
	int i;
	for (i = 0; i < m_arrRainbowChainWalk.GetSize(); i++)
	{
		if (memcmp(m_arrRainbowChainWalk[i].Hash, rcw.Hash, 8) == 0
			&& m_arrRainbowChainWalk[i].pIndexE == rcw.pIndexE)
		{
			delete[] m_arrRainbowChainWalk[i].pIndexE;
			m_arrRainbowChainWalk.RemoveAt(i);
			return;
		}
	}
}
