// TradeoffContext.h: interface for the CTradeoffContext class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRADEOFFCONTEXT_H__FB83AA77_0F24_48C9_AF92_F037D5C23508__INCLUDED_)
#define AFX_TRADEOFFCONTEXT_H__FB83AA77_0F24_48C9_AF92_F037D5C23508__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CTradeoffContext
{
public:
	CTradeoffContext();
	virtual ~CTradeoffContext();

private:
	static BYTE m_PlainCharset[1024];
	static int m_nPlainCharsetLength;
	static CString m_sPlainCharset;
	static CString m_sPlainCharsetContent;
	static unsigned __int64 m_nPlainSpaceUpToX[8];
	static unsigned __int64 m_nPlainSpaceTotal;
	static int m_nRainbowTableIndex;
	static unsigned __int64 m_nReduceOffset;

	// Context
	unsigned __int64 m_nIndex;
	BYTE m_Plain[7];
	BYTE m_Hash[8];

public:
	static void GetAllCharset(CMapStringToString& mapCharsetNameCharset);
	static BOOL SetPlainCharset(CString sPlainCharset);
	static CString GetPlainCharset();
	static CString GetPlainCharsetContent();
	static BOOL SetRainbowTableIndex(int nRainbowTableIndex);
	static int GetRainbowTableIndex();

	void GenerateRandomIndex();
	void SetIndex(unsigned __int64 nIndex);
	void SetHash(BYTE Hash[8]);
	void IndexToPlain();
	void PlainToHash();
	void HashToIndex(int nPosition);

	unsigned __int64 GetPlainSpaceTotal();
	unsigned __int64 GetIndex();
	CString GetPlain();
	CString GetHash();
	BOOL CheckHash(BYTE Hash[8]);
	void DumpPlain(unsigned __int64 nIndexFrom, unsigned __int64 nIndexTo);
};

#endif // !defined(AFX_TRADEOFFCONTEXT_H__FB83AA77_0F24_48C9_AF92_F037D5C23508__INCLUDED_)
